//
// Copyright (c) 2014 Secret Geometry, Inc.  All rights reserved.
//

#ifndef TERMKIT_KEYBOARD_HPP
#define TERMKIT_KEYBOARD_HPP

#include "Types.hpp"

namespace term
{

template
<
    typename ConnectionClass
>
class Keyboard
{
  public:
    
    Keyboard(ConnectionClass& connection)
    :
        _connection(connection)
    {
        // nothing
    }
    
    void upArrowKey()       { write(ESC_STRING "OA"); }
    void downArrowKey()     { write(ESC_STRING "OB"); }
    void rightArrowKey()    { write(ESC_STRING "OC"); }
    void leftArrowKey()     { write(ESC_STRING "OD"); }
    void moveWordLeft()     { write(ESC_STRING "b"); }
    void moveWordRight()    { write(ESC_STRING "f"); }
    void forwardDeleteKey() { write(CSI_PREFIX_STRING "3~"); }
    void pageUpKey()        { write(CSI_PREFIX_STRING "5~"); }
    void pageDownKey()      { write(CSI_PREFIX_STRING "6~"); }
    
    void functionKey(int index)
    {
        switch (index)
        {
            case 1:  write(ESC_STRING "OP"); break;
            case 2:  write(ESC_STRING "OQ"); break;
            case 3:  write(ESC_STRING "OR"); break;
            case 4:  write(ESC_STRING "OS"); break;
                
            case 5:  write(CSI_PREFIX_STRING "15~"); break;
            case 6:  write(CSI_PREFIX_STRING "17~"); break;
            case 7:  write(CSI_PREFIX_STRING "18~"); break;
            case 8:  write(CSI_PREFIX_STRING "19~"); break;
            case 9:  write(CSI_PREFIX_STRING "20~"); break;
            case 10: write(CSI_PREFIX_STRING "21~"); break;
            case 11: write(CSI_PREFIX_STRING "23~"); break;
            case 12: write(CSI_PREFIX_STRING "24~"); break;
            case 13: write(CSI_PREFIX_STRING "25~"); break;
            case 14: write(CSI_PREFIX_STRING "26~"); break;
            case 15: write(CSI_PREFIX_STRING "28~"); break;
            case 16: write(CSI_PREFIX_STRING "29~"); break;
            case 17: write(CSI_PREFIX_STRING "31~"); break;
            case 18: write(CSI_PREFIX_STRING "32~"); break;
            case 19: write(CSI_PREFIX_STRING "33~"); break;
            case 20: write(CSI_PREFIX_STRING "34~"); break;
        }
    }
    
  private:
    
    void write(const char* s)
    {
        _connection.write((const uint8_t*)s, strlen(s));
    }
    
    ConnectionClass& _connection;
};

}

#endif
