//
//  TermKit.hpp
//  TermKit
//
//  Created by Colin Caufield on 2013-04-03.
// Copyright (c) 2014 Secret Geometry, Inc.  All rights reserved.
//

#ifndef TERMKIT_TERMKIT_HPP
#define TERMKIT_TERMKIT_HPP

#include "Terminal.hpp"
#include "Config.hpp"
#include "Debug.hpp"
#include "Types.hpp"
#include "Rect.hpp"
#include "Ascii.hpp"
#include "Context.hpp"
#include "TextArea.hpp"
#include "Dispatcher.hpp"
#include "Parser.hpp"
#include "Palette.hpp"
#include "Keyboard.hpp"
#include "Ssh.hpp"
#include "Pty.hpp"

namespace term
{
    typedef Terminal<Ssh, Keyboard<Ssh>, TextArea, Context, Dispatcher, Parser> SshTerminal;
    
    typedef Terminal<Pty, Keyboard<Pty>, TextArea, Context, Dispatcher, Parser> PtyTerminal;
}

#endif
